| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoTextureCoordinatePlane Class Reference
Node Classes

The SoTextureCoordinatePlane class generates texture coordinates by projecting onto a plane.SoTextureCoordinatePlane is used for generating texture coordinates by projecting the object onto a texture plane. The s, t and r texture coordinates are computed as the distance from the origin to the projected point, in the respective directions. The texture plane is specified using two direction vectors, given as SoTextureCoordinatePlane::directionS and SoTextureCoordinatePlane::directionT in object space coordinates. SoTextureCoordinatePlane::directionR is used for generating the third coordinate, and can be used for generating texture coordinate for 3D textures. For 2D textures you can just leave this field alone. More...

`#include <Inventor/nodes/SoTextureCoordinatePlane.h>`

Inheritance diagram for SoTextureCoordinatePlane:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoTextureCoordinatePlane (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | callback (SoCallbackAction *action)
Public Member Functions inherited from SoTextureCoordinateFunction
| SoTextureCoordinateFunction (void)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoTextureCoordinateFunction
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec3f | directionS
SoSFVec3f | directionT
SoSFVec3f | directionR

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTextureCoordinatePlane ()
Protected Member Functions inherited from SoTextureCoordinateFunction
virtual | ~SoTextureCoordinateFunction ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTextureCoordinateFunction
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTextureCoordinatePlane class generates texture coordinates by projecting onto a plane.

SoTextureCoordinatePlane is used for generating texture coordinates by projecting the object onto a texture plane. The s, t and r texture coordinates are computed as the distance from the origin to the projected point, in the respective directions. The texture plane is specified using two direction vectors, given as SoTextureCoordinatePlane::directionS and SoTextureCoordinatePlane::directionT in object space coordinates. SoTextureCoordinatePlane::directionR is used for generating the third coordinate, and can be used for generating texture coordinate for 3D textures. For 2D textures you can just leave this field alone.

The length of the vector determines the repeat interval of the texture per unit length.

A simple usage example:

SoSeparator *root = new SoSeparator;
root->ref();
// the texture image
SoTexture2 *tex = new SoTexture2;
tex->filename.setValue("foo.png");
root->addChild(tex);
// the texture plane
SoTextureCoordinatePlane *texPlane = new SoTextureCoordinatePlane;
texPlane->directionS.setValue(SbVec3f(1,0,0));
texPlane->directionT.setValue(SbVec3f(0,1,0));
root->addChild(texPlane);
// add a simple cube
SoCube * c = new SoCube;
c->width.setValue(1.0);
c->height.setValue(1.0)
c->depth.setValue(1.0);
root->addChild(new SoCube);

Here, we are projecting a texture onto a cube. The texture coordinate plane is specified by directionS = (1,0,0) and directionT = (0,1,0), meaning that it is parallel to the front face of the cube. Setting e.g. directionS = (0,1,0) and directionT = (-1,0,0) would rotate the texture counterclockwise by 90 degrees. Setting them to ((2,0,0), (0,2,0)) results to the texture being repeated twice per unit, so the texture appears four times on the 1x1 face.

Note that when you transform the cube, the transformation will also affect the texture - it will be transformed vs. the rest of the world, but appear "fixed" on the object. If you want to change the placement of the texture on the object, you have to insert a SoTexture2Transform node before the texture coordinate plane. For instance in the example above, since the cube is centered in its coordinate system, the lower left corner of the texture appears to be in the middle of the face. To move the texture's origin to coincide with the lower left corner of the face, insert

SoTexture2Transform * tf = new SoTexture2Transform;
tf->translation.setValue(-0.5,-0.5);
root->addChild(tf);

before adding the texture coordinate plane.

FILE FORMAT/DEFAULTS:

TextureCoordinatePlane {
directionS 1 0 0
directionT 0 1 0
}

## Constructor & Destructor Documentation

## ◆ SoTextureCoordinatePlane()

SoTextureCoordinatePlane::SoTextureCoordinatePlane | ( | void |  | ) |

Constructor.

## ◆ ~SoTextureCoordinatePlane()

SoTextureCoordinatePlane::~SoTextureCoordinatePlane | ( |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoTextureCoordinatePlane::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoTextureCoordinateFunction.

## ◆ getFieldData()

const SoFieldData * SoTextureCoordinatePlane::getFieldData | ( | void |  | ) | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTextureCoordinateFunction.

## ◆ doAction()

void SoTextureCoordinatePlane::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ GLRender()

void SoTextureCoordinatePlane::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoNode.

## ◆ pick()

void SoTextureCoordinatePlane::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## ◆ callback()

void SoTextureCoordinatePlane::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## Member Data Documentation

## ◆ directionS

SoSFVec3f SoTextureCoordinatePlane::directionS

The S texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

## ◆ directionT

SoSFVec3f SoTextureCoordinatePlane::directionT

The T texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

## ◆ directionR

SoSFVec3f SoTextureCoordinatePlane::directionR

The R texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

The documentation for this class was generated from the following files:

- SoTextureCoordinatePlane.h
- SoTextureCoordinatePlane.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.